/*
 * The main file for the program
 */


#include "main-tcp.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <netdb.h>
#include <dirent.h>
#include <pwd.h>
#include "mail.h"
#include "misc.h"
#include "pop3.h"
#include "get-mail.h"
#include "get_mail_setup.h"
#include <paths.h>

/* 
 * The program should only run once at a time for a user.
 * thats why I lock it...
 */
int Lock_prog (char*user)
{
   char*Komplett;
   int lockfile;
   Komplett = (char*)malloc(255*sizeof(char));
   if (!Komplett)
     return 0;
   Komplett = strcpy(Komplett,_PATH_TMP);
   Komplett = strcat(Komplett, user);
   Komplett = strcat(Komplett, ".get-mail.lock");
   lockfile = open(Komplett,O_CREAT | O_EXCL | O_RDWR);
   if (lockfile == -1)
     return -1;
   close(lockfile);
   chmod(Komplett, S_IRUSR | S_IWUSR);
   return 1;
}

/*
 * After a downloading and putting the mail
 * we can unlock it.
 */
int Unlock_prog (char*user)
{
   char*Komplett;
   Komplett = (char*)malloc(255*sizeof(char));
   if (!Komplett)
     return 0;
   Komplett = strcpy(Komplett,_PATH_TMP);
   Komplett = strcat(Komplett, user);
   Komplett = strcat(Komplett, ".get-mail.lock");
   if (unlink(Komplett) < 0)
     return -1;
   return 1;
}

/*
 * Getting the Infos about login etc.
 * and reading the ini-file
 */
Hostinfo*get_info(struct passwd*zgr){
   Hostinfo*Infos;
   FILE*ini_file;
   char*Home;
   char*dummy;
   int i;
   int runfile;
   char*Kompletter_Pfad;
   Infos = (Hostinfo*)malloc(sizeof(Hostinfo));
   Infos->usr = NULL;
   Infos->pass = NULL;
   Infos->host = NULL;
   if (Infos == NULL)
     return NULL;
   if (zgr==NULL) {
      fprintf(stderr,"could not get user-infos!\n");
      exit(1);
   }
   Home = strdup(zgr->pw_dir);
   if (Home == NULL) {
      free(Infos);
      fprintf(stderr,"Could not get Home-Dir!\n");
      exit(1);
   }
   Kompletter_Pfad = (char*)malloc(256*sizeof(char));
   if (Kompletter_Pfad == NULL) {
      fprintf(stderr,"Error allocating memory!\n");
      exit(1);
   }
   Kompletter_Pfad=strcpy(Kompletter_Pfad,Home);
   Kompletter_Pfad=strcat(Kompletter_Pfad,"/.get_mail/initmail");
   dummy = (char*)malloc(256*sizeof(char));
   if (dummy == NULL) {
      fprintf(stderr, "Error allocating memory!\n");
      exit(1);
   }
   dummy = strcpy(dummy, Home);
   dummy = strcat(dummy,"/.get_mail/last_start");
   unlink(dummy);
   runfile = creat(dummy, S_IRUSR|S_IWUSR);
   if (runfile > 0)
     close(runfile);
   free(Home);
   free(dummy);
   ini_file = fopen(Kompletter_Pfad,"r");
   if (ini_file == NULL) {
      i = errno;
      if (i == ENOENT) {
	 free(Kompletter_Pfad);
	 free(Infos);
	 fprintf(stderr,"Please run first setup with option \"-s\"!\n");
	 exit(1);
      }
      else if (i == ENOMEM) {
	 fprintf(stderr,"%s\n",strerror(i));
	 exit(1);
      }
      else {
	 free(Kompletter_Pfad);
	 free(Infos);
	 fprintf(stderr,"Please run first setup with option \"-s\"!\n");
	 exit(1);
      }
   }
   Home = (char*)malloc(256*sizeof(char));
   while (fgets(Home,255,ini_file)) {
      if (strstr(Home,"Host: ")) {
	 dummy = strchr(Home,' ');
	 dummy = &dummy[1];
	 if (strstr(dummy,"\n")) {
	    dummy[strlen(dummy)-1] = '\0';
	    i = 1;
	 } else
	   i = 0;
	 Infos->host = strdup(dummy);
	 if (i) 
	   dummy[strlen(dummy)] = '\n';
      }
      else
	if (strstr(Home, "User: ")) {
	   dummy = strchr(Home, ' ');
	   dummy = &dummy[1];
	   if (strstr(dummy, "\n")) {
	      dummy[strlen(dummy)-1] = '\0';
	      i = 1;
	   } else
	     i = 0;
	   Infos->usr = strdup(dummy);
	   if (i) 
	     dummy[strlen(dummy)] = '\n';
	}
      else if (strstr(Home, "Pass: ")) {
	 dummy = strchr(Home, ' ');
	 dummy = &dummy[1];
	 if (strstr(dummy,"\n")) {
	    dummy[strlen(dummy)-1] = '\0';
	    i = 1;
	 } else
	   i = 0;
	 Infos->pass = strdup(dummy);
	 if (i) 
	   dummy[strlen(dummy)] = '\n';
      }
   }
   free(Home);
   fclose(ini_file);
   if ( (!(Infos->pass)) || (!(Infos->host)) || (!(Infos->usr)) ) {
      free(Infos);
      Infos = NULL;
   }
   return Infos;
}

/*
 * The main routine
 * very long, to long?
 * Next versions i'll split into more parts.
 */
int main(int argc, char*argv[]) {
   Hostinfo * Infos;
   pop3_data*Mail;
   unsigned char*buffer;
   unsigned char*mailfile;
   struct passwd*zgr;
   int QUIET;
   int NODEL;
   int Log;
   int c;
   mail_Liste * Liste;
   mail_Liste * dummy_Liste;
   int i;
   QUIET = 0;
   NODEL = 0;
   zgr=get_user_name(1);
   if (Lock_prog(zgr->pw_name) < 0) {
      if (errno==EEXIST) {
	 printf("I think, the programs already runs, if not,\n");
	 printf("remove the file %s%s.get-mail.locked.\n",_PATH_TMP,zgr->pw_name);
	 printf("May be, that there were any errors and I could not remove\n");
	 printf("the lock-file. But-- remove it only, you're sure, there's no\n");
	 printf("other session running....\n");
	 exit(1);
      }
      else {
	 fprintf(stderr, "An error during locking the program:\n");
	 fprintf(stderr,"%s\n",strerror(errno));
      }
   }
   Log = 1;
   while ((c = getopt (argc, argv, "qdshvl?")) != -1) {
      switch(c){
       case 'q':
	 QUIET=1;
	 break;
       case 's':
	 get_mail_setup(zgr->pw_dir);
	 Unlock_prog(zgr->pw_name);
	 exit(0);
       case 'd':
	 NODEL=1;
	 break;
       case 'l':
	 Log=0;
	 break;
       case 'v':
       case 'h':
       case '?':
       default:
	 fprintf(stderr,"get-mail Version 0.1 very alpha\n");
	 fprintf(stderr,"Usage: get-mail <-sqhd>\n");
	 fprintf(stderr,"-h: Get this Info\n");
	 fprintf(stderr,"-s: running setup\n");
	 fprintf(stderr,"-q: QUIET-Mode, do not print run-infos\n");
	 fprintf(stderr,"-d: Do not delete received messages on Server\n");
	 exit(1);
      }
   }
   Infos = get_info(zgr);
   if(!(Infos)) {
      fprintf(stderr, "Error getting user - infos!");
      exit(1);
   }
   if (!(QUIET)) {
      printf("connecting to server\n");
   }
   Mail = connect_pop3(Infos->host,Infos->usr,Infos->pass);
   if (!(Mail->socket > 0)) {
      if (errno == -1){
	 herror("Error open connection");
      }
      else {
	 fprintf(stderr,"Error open connection: ");
	 fprintf(stderr,"%s",strerror(errno)); 
         fprintf(stderr,"\n");
      }
      Unlock_prog(zgr->pw_name);
      exit(1);
   }
   if (!(Mail->User_reply)) {
      fprintf(stderr, "Error: Username not accepted\n");
      write_data(Mail->socket, "QUIT\r\n",6);
      close(Mail->socket);
      Unlock_prog(zgr->pw_name);
      exit(1);
   }
   if (!(Mail->Pass_reply)) {
      fprintf(stderr, "Error: Bad login (Not correct Password?)\n");
      write_data(Mail->socket,"QUIT\r\n",6);
      close(Mail->socket);
      Unlock_prog(zgr->pw_name);
      exit(1);
   }
   POP3_Status(Mail);
   if (Mail->status_zahl > 0) {
      Liste = POP3_Liste(Mail);
      buffer =(unsigned char*)malloc(255*sizeof(char));
      if (buffer== NULL) {
	 fprintf(stderr, "insufficient memory\n");
	 Unlock_prog(zgr->pw_name);
	 exit(1);
      }
      mailfile = (unsigned char*)malloc(255*sizeof(char));
      if (mailfile == NULL) {
	 fprintf(stderr, "insufficient memory\n");
	 Unlock_prog(zgr->pw_name);
	 exit(1);
      }
      strcpy(mailfile, _PATH_MAILDIR);
      mailfile = strcat(mailfile,"/");
      mailfile = strcat(mailfile, zgr->pw_name);
      buffer = tmpnam(NULL);
      if (!(Liste == NULL)) {
	 dummy_Liste = Liste;
	 while (!(dummy_Liste == NULL)){
	    if (QUIET==0) {
	       printf("getting mail No %lu (%lu bytes) ",dummy_Liste->Number, dummy_Liste->Bytes);
	    }
	    i = POP3_getmsg(Mail, dummy_Liste->Number, buffer);
	    if (convert_to_unix(buffer) < 1) {
	       fprintf(stderr,"Error converting mail!\n");
	       Unlock_prog(zgr->pw_name);
	       exit(1);
	    }
	    if (!( (create_mail_entry(mailfile, buffer,zgr->pw_name)) == 1)) {
	       fprintf(stderr, "Error creating mailentry\n");
	       Unlock_prog(zgr->pw_name);
	       exit(1);
	    }
	    if (QUIET == 0) 
	      printf("- done");
	    if (!NODEL) {
	       if(QUIET==0) 
		 printf(" - delete on host");
	       POP3_delmsg(Mail, dummy_Liste);
	    }
	    if (QUIET == 0)
	      printf("\n");
	    dummy_Liste = dummy_Liste->Next;
	    free(Liste);
	    Liste = dummy_Liste;
	 }
      }
   }
   Unlock_prog(zgr->pw_name);
   return 0;
}
